// Copyright (c) 2012, Alexandre Ardhuin
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

part of realtime_data_model;

class ErrorType extends IsEnum<String> {
  static final CONCURRENT_CREATION = new ErrorType._(realtime['ErrorType']['CONCURRENT_CREATION']);
  static final INVALID_COMPOUND_OPERATION = new ErrorType._(realtime['ErrorType']['INVALID_COMPOUND_OPERATION']);
  static final INVALID_JSON_SYNTAX = new ErrorType._(realtime['ErrorType']['INVALID_JSON_SYNTAX']);
  static final MISSING_PROPERTY = new ErrorType._(realtime['ErrorType']['MISSING_PROPERTY']);
  static final NOT_FOUND = new ErrorType._(realtime['ErrorType']['NOT_FOUND']);
  static final FORBIDDEN = new ErrorType._(realtime['ErrorType']['FORBIDDEN']);
  static final SERVER_ERROR = new ErrorType._(realtime['ErrorType']['SERVER_ERROR']);
  static final CLIENT_ERROR = new ErrorType._(realtime['ErrorType']['CLIENT_ERROR']);
  static final TOKEN_REFRESH_REQUIRED = new ErrorType._(realtime['ErrorType']['TOKEN_REFRESH_REQUIRED']);
  static final INVALID_ELEMENT_TYPE = new ErrorType._(realtime['ErrorType']['INVALID_ELEMENT_TYPE']);
  static final NO_WRITE_PERMISSION = new ErrorType._(realtime['ErrorType']['NO_WRITE_PERMISSION']);

  static final _INSTANCES = [CONCURRENT_CREATION, INVALID_COMPOUND_OPERATION,
    INVALID_JSON_SYNTAX, MISSING_PROPERTY, NOT_FOUND, FORBIDDEN, SERVER_ERROR,
    CLIENT_ERROR, TOKEN_REFRESH_REQUIRED, INVALID_ELEMENT_TYPE,
    NO_WRITE_PERMISSION];

  static ErrorType find(Object o) => findIn(_INSTANCES, o);

  ErrorType._(String value) : super(value);

  bool operator ==(Object other) => value == (other is ErrorType ? other.value : other);
}